﻿<template>
    <section class="header-my-movies">
        <h2 class="page-title">{{ t('pages.myMovies.title') }}</h2>
        <form>
            <FormSelect 
                v-if="!searchValue" 
                :name="t('pages.myMovies.filter')" 
                :options="formOptions" 
                :modelValue="filterOption" 
                @update:modelValue="handleFilterChange"></FormSelect>

            <SearchInput :modelValue="searchValue" @update:modelValue="handleSearchInput" />
        </form>
    </section>
    <Suspense>
        <section class="my-movies">
            <article class="my-movie" v-for="movie in movies" :key="movie.id">
                <h2>{{movie.movie.title}}</h2>
                <img :src="movie.movie.image" :alt="movie.movie.title" />

                <div class="movie-info">
                    <p class="movie-date">
                        <span>{{ t('pages.showMovie.releaseDate') }} : </span>{{ movie.movie.year }}
                    </p>
                    <p class="movie-timeline">
                        <span>{{ t('pages.showMovie.duration') }} : </span>{{ movie.movie.timeline }}
                    </p>
                </div>

                <div class="my-movie-btns">
                    <!--<button class="delete-movie-btn btn">Partager</button>-->
                    <button class="delete-movie-btn btn" @click="deleteMovie(movie.movie.id)">{{ t('global.delete') }}</button>
                </div>
            </article>

            <p v-if="movies.length == 0 && !searchValue">{{ t('pages.myMovies.noMovies') }}</p>
            <p v-if="searchValue && movies.length == 0">
                {{ t('pages.myMovies.noMoviesSearch') }}
            </p>
        </section>
        <template #fallback>
            <Loader />
        </template>
    </Suspense>
    <section class="pagination" v-if="!searchValue && movies.length > 0">
        <div>
            <button @click="goFirst"
                    :class="{'btn': true, 'btn--disabled': currPage==0}">
                &lArr;
            </button>
            <button @click="changePage(-1)"
                    :class="{'btn': true, 'btn--disabled': currPage==0}">
                &larr;
            </button>
        </div>
        
        <p>{{currPage + 1}}</p>

        <div>
            <button @click="changePage(1)"
                    :class="{'btn': true, 'btn--disabled': currPage==maxPossiblePage}">
                &rarr;
            </button>
            <button @click="goLast"
                    :class="{'btn': true, 'btn--disabled': currPage==maxPossiblePage}">
                &rArr;
            </button>
        </div>
    </section>
</template>

<script setup lang="ts">
    import Loader from "@/components/layout/Loader.vue";
    import SearchInput from "@/components/layout/SearchInput.vue";
    import FormSelect from "@/components/forms/FormSelect.vue";
    import { useI18n } from "vue3-i18n";
    import { useMovieService, useMovieMemberService } from "@/inversify.config";
    import { useMemberStore } from "@/stores/memberStore";
    import { ref } from 'vue';
    import {notifyError, notifySuccess} from "@/notify";
    import { IGetMoviesByMemberRequest } from "../../types/requests";
    import { MovieMember } from "../../types";
    import { FormOption } from "@/types/formOption";

    const movieService = useMovieService();
    const movieMemberService = useMovieMemberService();
    const memberStore = useMemberStore();
    const { t } = useI18n();

    const movies = ref<MovieMember[]>();
    const takeValue = 12;
    const currPage = ref(0);
    let maxPossiblePage = await getMaxPossiblePage();

    let getMoviesByMemberReq: IGetMoviesByMemberRequest = {
        memberId: memberStore.member.id,
        skip: 0,
        take: takeValue,
        descending: false,
        orderByName: true
    }

    const formOptions: FormOption[] = [
        { name: 'nameAscending', label: 'Nom (croissant)' },
        { name: 'nameDescending', label: 'Nom (décroissant)' },
        { name: 'dateAscending', label: 'Date d\'ajout (croissant)' },
        { name: 'dateDescending', label: 'Date d\'ajout (décroissant)' },
    ];
    let filterOption = 'nameAscending';

    function handleFilterChange(value: string) {
        if (value === 'nameAscending') {
            getMoviesByMemberReq.descending = false;
            getMoviesByMemberReq.orderByName = true;
        }
        else if (value === 'nameDescending') {
            getMoviesByMemberReq.descending = true;
            getMoviesByMemberReq.orderByName = true;
        }
        else if (value === 'dateAscending') {
            getMoviesByMemberReq.descending = false;
            getMoviesByMemberReq.orderByName = false;
        }
        else {
            getMoviesByMemberReq.descending = true;
            getMoviesByMemberReq.orderByName = false;
        }

        updateMovies();
    }

    movies.value = await movieMemberService.getMoviesByMember(getMoviesByMemberReq);

    let searchValue = "";
    async function handleSearchInput(value: string) {
        searchValue = value;
        if (searchValue === "")
            updateMovies();
        else
            movies.value = await movieMemberService.getMoviesByMemberAndTitle({ memberId: memberStore.member.id, title: searchValue });
    }

    async function deleteMovie(movieId: string) {
        let confirmDelete = confirm(t("validation.movie.delete.confirmation"));
        if (!confirmDelete)
            return;

        let response = await movieService.removeMemberLink(movieId, memberStore.member.id);
        if (response.succeeded) {
            notifySuccess(t('validation.movie.delete.success'));
            updateMovies();
             maxPossiblePage = await getMaxPossiblePage();
        } else {
            notifyError(t('validation.movie.delete.errorOccured'));
        }
    }

    async function changePage(val: number) {
        currPage.value += val;
        if (currPage.value < 0)
            currPage.value = 0;
        else if (currPage.value > maxPossiblePage)
            currPage.value = maxPossiblePage;

        await updateMovies();
        backToTop();
    }

    async function goLast() {
        currPage.value = maxPossiblePage;
        await updateMovies();
        backToTop();
    }

    async function goFirst() {
        currPage.value = 0;
        await updateMovies();
        backToTop();
    }

    async function updateMovies() {
        getMoviesByMemberReq.skip = currPage.value * takeValue;
        movies.value = await movieMemberService.getMoviesByMember(getMoviesByMemberReq);
    }

    async function getMaxPossiblePage() {
        const moviesCount = await movieMemberService.getMoviesByMemberCount(memberStore.member.id);
        return Math.ceil(moviesCount / takeValue) - 1;
    }

    function backToTop() {
        if (document.documentElement.scrollTop > 20 || document.body.scrollTop > 20) {
            document.body.scrollTop = 0; // For Safari
            document.documentElement.scrollTop = 0; // For Chrome, Firefox, IE and Opera
        }
    }
</script>